> ## Documentation Index
> Fetch the complete documentation index at: https://developers.myhero.so/llms.txt
> Use this file to discover all available pages before exploring further.

# Upload an image

> Uploads an image asset and stores its metadata.

The image bytes are accepted as `{ type: "Buffer", data: number[] }` (RTK-Query encoded buffer) and uploaded to private object storage.

Returns the image record including its `_id` and a signed URL valid for 6 hours.

Supply either `documentId` (document-scoped) or `tableId` (table-scoped).



## OpenAPI

````yaml post /media/image
openapi: 3.1.0
info:
  title: HERO API
  version: current
  description: |-
    The HERO REST API.

    See https://developers.myhero.so for the rendered docs.
servers:
  - url: https://app.myhero.so
security: []
paths:
  /media/image:
    post:
      tags:
        - Media
      summary: Upload an image
      description: >-
        Uploads an image asset and stores its metadata.


        The image bytes are accepted as `{ type: "Buffer", data: number[] }`
        (RTK-Query encoded buffer) and uploaded to private object storage.


        Returns the image record including its `_id` and a signed URL valid for
        6 hours.


        Supply either `documentId` (document-scoped) or `tableId`
        (table-scoped).
      operationId: createImage
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                documentId:
                  type: string
                  minLength: 1
                tableId:
                  type: string
                  minLength: 1
                workspaceId:
                  type: string
                  minLength: 1
                image:
                  type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - Buffer
                    data:
                      type: array
                      items:
                        type: integer
                        minimum: 0
                        maximum: 255
                  required:
                    - type
                    - data
              required:
                - image
      responses:
        '200':
          description: 200 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    type: object
                    properties:
                      url:
                        type: string
                      _id:
                        type: string
                    required:
                      - url
                      - _id
                required:
                  - data
        '400':
          description: 400 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: |-
                      Error class name (e.g.

                      ValidationError, NotFound)
                  message:
                    type: string
                    description: Human-readable error message
                  details:
                    type: array
                    items: {}
                required:
                  - error
                  - message
        '403':
          description: 403 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: |-
                      Error class name (e.g.

                      ValidationError, NotFound)
                  message:
                    type: string
                    description: Human-readable error message
                  details:
                    type: array
                    items: {}
                required:
                  - error
                  - message
        '500':
          description: 500 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: |-
                      Error class name (e.g.

                      ValidationError, NotFound)
                  message:
                    type: string
                    description: Human-readable error message
                  details:
                    type: array
                    items: {}
                required:
                  - error
                  - message
      security:
        - bearerAuth: []
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: HERO personal access token

````